#include "testApp.h"



//--------------------------------------------------------------
void testApp::setup(){

	ofBackground(255,255,255);

	// 2 output channels,
	// 0 input channels
	// 44100 samples per second
	// 256 samples per buffer
	// 4 num buffers (latency)

	ofSoundStreamSetup(2,0,this, 44100,256, 4);

	ofSetFrameRate(60);
	
	frequency = 120;
	sampleCount = 0;

}


//--------------------------------------------------------------
void testApp::update(){

}

//--------------------------------------------------------------
void testApp::draw(){

	ofSetColor(0,0,0);
	ofDrawBitmapString("frequency = " + ofToString(frequency), 50, 50);

}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	frequency = y;			// changing frequencies is crunchy.  let's talk about that !! 

}


//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}
//--------------------------------------------------------------
void testApp::audioRequested 	(float * output, int bufferSize, int nChannels){

	for (int i = 0; i < bufferSize; i++){
		
		
		float pctOfSecond = (sampleCount) / 44100.0f;					// where is this sample in one second as a percentage ?
		float sample = sin( pctOfSecond * TWO_PI * frequency );			// multiply that pct x TWO_PI (one revolution of a circle) x frequency (rotations per second)
		
		output[i * 2 + 0] = sample;			// left channel
		output[i * 2 + 1] = sample;			// right channel
		
		sampleCount++;
		
	}
	
	sampleCount %= 44100;	// keep sample count from getting too high (and wrapping) and sin(...) from having a really large value to plug in.  when we take
							// sin of very large values, it gets less precise.... 

}

